from __future__ import print_function;
import pickle
import os.path
import json
import datetime
from googleapiclient.discovery import build
from google.oauth2.credentials import Credentials
from google_auth_oauthlib.flow import InstalledAppFlow
from google.auth.transport.requests import Request
from googleapiclient.errors import HttpError

# If modifying these scopes, delete the file token.json.

def calEvents():
    SCOPES = ['https://www.googleapis.com/auth/calendar.readonly']
    """Shows basic usage of the Google Calendar API.
    Prints the start and name of the next 10 events on the user's calendar.
    """
    creds = None
    # The file token.json stores the user's access and refresh tokens, and is
    # created automatically when the authorization flow completes for the first
    # time.
    if os.path.exists('token.json'):
        creds = Credentials.from_authorized_user_file('token.json', SCOPES)
    # If there are no (valid) credentials available, let the user log in.
    if not creds or not creds.valid:
        if creds and creds.expired and creds.refresh_token:
            creds.refresh(Request())
        else:
            flow = InstalledAppFlow.from_client_secrets_file(
                'credentials.json', SCOPES)
            creds = flow.run_local_server(port=0)
        # Save the credentials for the next run
        with open('token.json', 'w') as token:
            token.write(creds.to_json())

    try:
        service = build('calendar', 'v3', credentials=creds)

        # Call the Calendar API
        today = datetime.datetime.today();
        start = (datetime.datetime(today.year, today.month, today.day, 00, 00)).isoformat() + 'Z'
        tomorrow = today + datetime.timedelta(days=3)
        end =  (datetime.datetime(tomorrow.year, tomorrow.month, tomorrow.day, 00, 00)).isoformat() + 'Z'
        now = datetime.datetime.utcnow().isoformat() + 'Z'  # 'Z' indicates UTC time
        # print('Getting the upcoming 10 events')
        # primary_events_result = service.events().list(calendarId="primary", timeMin=now,maxResults=2, singleEvents=True,orderBy='startTime').execute()
        primary_events_result = service.events().list(calendarId='primary', timeMin=start, timeMax=end, singleEvents=True, orderBy='startTime').execute()
        primary_events = primary_events_result.get('items', [])

        primary=[]
        # data.append({"pasadena":{}})
        # Prints the start and name of the next 10 events
        for event in primary_events:
            start=event['start'].get('dateTime', event['start'].get('date'))
            end=event['end'].get('dateTime', event['end'].get('date'))
            summary=event["summary"]
            #data.append({pasadena.start:start,pasadena.end:end,pasadena.summary:event["summary"] })
            primary.append({"start":start,"end":end,"summary":summary})
        if (len(primary)==0) :
            x1 = "-"
        else : x1 = len(primary)
        # print (x1)
        return(x1)
        # ev1=json.dumps(primary,separators=(',', ':'))
        # ev2=json.dumps(pasadena,separators=(',', ':'))
    except HttpError as error:
        print('An error occurred: %s' % error)

def count ():

    SCOPES = ['https://www.googleapis.com/auth/gmail.readonly']
    def ListMessagesMatchingQuery(service, user_id, query=''):
        """List all Messages of the user's mailbox matching the query.

        Args:
        service: Authorized Gmail API service instance.
        user_id: User's email address. The special value "me"
        can be used to indicate the authenticated user.
        query: String used to filter messages returned.
        Eg.- 'from:user@some_domain.com' for Messages from a particular sender.

        Returns:
        List of Messages that match the criteria of the query. Note that the
        returned list contains Message IDs, you must use get with the
        appropriate ID to get the details of a Message.
        """
        try:
            response = service.users().messages().list(userId=user_id,
                                                q=query).execute()
            messages = []
            if 'messages' in response:
                messages.extend(response['messages'])

            while 'nextPageToken' in response:
                page_token = response['nextPageToken']
                response = service.users().messages().list(userId=user_id, q=query,
                pageToken=page_token).execute()
                messages.extend(response['messages'])
            return messages
        except:
            print('An error occurred:')

            """Shows basic usage of the Gmail API.
        Lists the user's Gmail labels.
        """
    creds = None
    # The file token.pickle stores the user's access and refresh tokens, and is
    # created automatically when the authorization flow completes for the first
    # time.
    if os.path.exists('token.pickle'):
            with open('token.pickle', 'rb') as token:
                creds = pickle.load(token)
    # If there are no (valid) credentials available, let the user log in.
    if not creds or not creds.valid:
       if creds and creds.expired and creds.refresh_token:
        creds.refresh(Request())
       else:
        flow = InstalledAppFlow.from_client_secrets_file(
                'credentials.json', SCOPES)
        creds = flow.run_local_server(port=0)
        # Save the credentials for the next run
    with open('token.pickle', 'wb') as token:
       pickle.dump(creds, token)

    service = build('gmail', 'v1', credentials=creds)

    # resp, items = m.search(None, 'UNSEEN', 'label', '"Voice-SMS"')
    # unread_msgs = GMAIL.users().messages().list(userId='me',q='in:test is:unread').execute()
    voicemsg=len(ListMessagesMatchingQuery(service, "me","label:Voice-SMS is:unread"))
    if (voicemsg == 0) :
        voicemsg = "-"
    # email_count = len(ListMessagesMatchingQuery(service, "me", "label:unread category:primary"))
    # email_count1 = len(ListMessagesMatchingQuery(service, "me", "label:unread category:social"))
    # email_count2 = len(ListMessagesMatchingQuery(service, "me", "label:unread category:updates"))
    # email_count3 = len(ListMessagesMatchingQuery(service, "me", "label:unread category:promotions"))
    gmail= len(ListMessagesMatchingQuery(service, "me","label:unread"))
    if (gmail == 0) :
        gmail = "-"
    f = open("/tmp/gmail.json", "w+")
    print(json.dumps({"gmail": gmail, "gvoice": voicemsg,"gcal":calEvents()}, sort_keys=True),end="",file=f)
    # print(voicemsg)
    f.close()
count ()
