import QtQuick 2.9
import org.kde.plasma.core 2.1

Item {
    id:newsData
    height:45
    width:340

    Image {
        id:logo
        anchors.top:newsData.top
        anchors.left:newsData.left
        anchors.topMargin:10
        anchors.leftMargin:10
        source:"cnn.png"
        smooth:true
        width:24
        height:24
    }


    Text {
        id:mainArticle
        anchors.top:logo.top
        anchors.left:logo.right
        anchors.leftMargin:10
        anchors.topMargin:3
        text:jsonData.newsArticles[jsonData.articleCount]
        color:Theme.textColor
        font.pointSize:10
        width:newsData.width*.86
        wrapMode: Text.Wrap
        maximumLineCount: 1
        elide: Text.ElideRight


    MouseArea {
                id:ma2
                anchors.fill: parent
                hoverEnabled: true
                onEntered: parent.color=Theme.viewHoverColor
                onExited: parent.color=Theme.textColor
                onClicked:  Qt.openUrlExternally(jsonData.newsLinks[jsonData.articleCount])
                cursorShape :Qt.PointingHandCursor
              }
    }

    Rectangle {
        id:ts1
        anchors.horizontalCenter:parent.horizontalCenter
        anchors.top:logo.bottom
        anchors.topMargin:10
        width: parent.width*.95
        height: .5
        color: "#5b565d"
        antialiasing : true
    }
}
