import QtQuick 2.9
import QtQuick.Layouts 1.5
import org.kde.plasma.core 2.1
import QtGraphicalEffects 1.15

Item {
    id:root
    width:600
    height:330

    property string radarImage:"https://cdns.abclocal.go.com/three/ktrk/weather/16_9/SETX1_1280.jpg";
    property int imageVisible: 1
    property string initialSource:"https://cdns.abclocal.go.com/three/ktrk/weather/16_9/SETX1_1280.jpg"

    property int r1:9

    function setSource(source){
        var imageNew = imageVisible === 1 ? image2 : image1;
        var imageOld = imageVisible === 2 ? image2 : image1;

        imageNew.source = source;

        function finishImage(){
            if(imageNew.status === Component.Ready) {
                imageNew.statusChanged.disconnect(finishImage);
                imageVisible = imageVisible === 1 ? 2 : 1;
            }
        }

        if (imageNew.status === Component.Loading){
            imageNew.statusChanged.connect(finishImage);
        }
        else {
            finishImage();
        }
    }

    Image {
        id:image1
        anchors.top:txt1.bottom
        anchors.left:root.left
        anchors.topMargin:20
        source:radarImage
        smooth: false // allow opacity mask == false
        width: root.width
        fillMode:Image.PreserveAspectFit
        visible: false
        cache:true
        ///visible: imageVisible === 1
    }

    OpacityMask {
        anchors.fill: image1
        source: image1
        maskSource: Rectangle {    // whats behind mask is visible, adds rounded corners to radar image
            width: image1.width
            height: image1.height
            radius: 8
            antialiasing : true
            visible: false // this also needs to be invisible or it will cover up the image
        }

        MouseArea {
            id:ma1
            anchors.fill: parent
            acceptedButtons: Qt.LeftButton
            hoverEnabled: true
            onEntered:radarTimer.start();
            onExited:{
                radarTimer.stop()
                setSource("https://cdns.abclocal.go.com/three/ktrk/weather/16_9/SETX1_1280.jpg");
            }
            cursorShape:Qt.PointingHandCursor
            onClicked: {
                Qt.openUrlExternally("https://abc13.com/weather/")
            }
        }
    }


    Image {
        id:image2
        anchors.top:txt1.bottom
        anchors.left:root.left
        anchors.topMargin:20
        source:radarImage
        smooth: false // allow opacity mask == false
        width: root.width
        fillMode:Image.PreserveAspectFit
        visible: false
        cache:true
        //visible: imageVisible === 1
    }

    OpacityMask {
        anchors.fill: image2
        source: image2
        maskSource: Rectangle {    // whats behind mask is visible, adds rounded corners to radar image
            width: image2.width
            height: image2.height
            radius: 8
            antialiasing : true
            visible: false // this also needs to be invisible or it will cover up the image
        }

        MouseArea {
            id:ma2
            anchors.fill: parent
            acceptedButtons: Qt.LeftButton
            hoverEnabled: true
            onEntered:radarTimer.start();
            onExited:{
                radarTimer.stop()
                setSource("https://cdns.abclocal.go.com/three/ktrk/weather/16_9/SETX1_1280.jpg");
            }
            cursorShape:Qt.PointingHandCursor
            onClicked: {
                Qt.openUrlExternally("https://abc13.com/weather/")
            }
        }
    }



    function radarLoop () {
        if (r1===9) {
            setSource ("https://cdns.abclocal.go.com/three/ktrk/weather/16_9/SETX9_1280.jpg")
            r1-=1 }
            else if (r1===8) {
                setSource("https://cdns.abclocal.go.com/three/ktrk/weather/16_9/SETX8_1280.jpg")
                r1-=1 }
                else if (r1===7) {
                    setSource("https://cdns.abclocal.go.com/three/ktrk/weather/16_9/SETX7_1280.jpg")
                    r1-=1 }
                    else if (r1===6) {
                        setSource("https://cdns.abclocal.go.com/three/ktrk/weather/16_9/SETX6_1280.jpg")
                        r1-=1 }
                        else if (r1===5) {
                            setSource("https://cdns.abclocal.go.com/three/ktrk/weather/16_9/SETX5_1280.jpg")
                            r1-=1 }
                            else if (r1===4) {
                                setSource("https://cdns.abclocal.go.com/three/ktrk/weather/16_9/SETX4_1280.jpg")
                                r1-=1 }
                                else if (r1===3) {
                                    setSource("https://cdns.abclocal.go.com/three/ktrk/weather/16_9/SETX3_1280.jpg")
                                    r1-=1 }
                                    else if (r1===2) {
                                        setSource("https://cdns.abclocal.go.com/three/ktrk/weather/16_9/SETX2_1280.jpg")
                                        r1-=1 }
                                        else if (r1===1) {
                                            setSource("https://cdns.abclocal.go.com/three/ktrk/weather/16_9/SETX1_1280.jpg")
                                            radarTimer.stop();
                                            pauseTimer.start();
                                            r1=9 }
    }


    Timer {
        id:radarTimer
        running:false
        repeat:true
        interval:300
        onTriggered:radarLoop ();
    }


    Timer {
        id:pauseTimer
        running:false
        repeat:false
        interval:1500
        onTriggered:{
            radarTimer.restart();
            radarLoop ();
        }
    }
}
