import QtQuick 2.9
import org.kde.plasma.core 2.1

Rectangle {
    id:scoresMain
    width:340
    height:75
    color:"black"

    GetData{id:jsonData}

   function getOrdinal(n) {            // assigns superfix to inning
       var s=["th","st","nd","rd"],
       v=n%100;
       return (s[(v-20)%10]||s[v]||s[0]);
   }

   function refreshGameData () {
       jsonData.getData(jsonData.url4);
   }

   function winningTeam (x){
        var c=""
        if (jsonData.gameStatusState == "post") {
        x ? c="white":c="gray"
        }
        else c="white"
    return c
    }

    Rectangle {
        id:rect1
        width:scoresMain.width*.995
        height:72
        antialiasing : true
        color:"transparent"
        border.color:"transparent"
        radius:8
        anchors.top:scoresMain.top
        anchors.left:scoresMain.left
        anchors.leftMargin:2
        anchors.rightMargin:2

        MouseArea {
            id: mouseArea1a
            anchors.fill: parent
            cursorShape:  Qt.PointingHandCursor
            hoverEnabled:true
            acceptedButtons: Qt.LeftButton | Qt.MiddleButton
            onEntered:parent.border.color=Theme.viewHoverColor
            onExited:parent.border.color="transparent"
            onClicked:(mouse.button==Qt.LeftButton) ? Qt.openUrlExternally(jsonData.gameBoxScoresURL) : refreshGameData()
        }

        Image{
            id:atl
            source:jsonData.awayTeamLogo
            //height:36
            width:32
            anchors.right:ateam.left
            anchors.top:rect1.top
            anchors.leftMargin:10
            anchors.rightMargin:15
            anchors.topMargin:10
            //smooth:true
            antialiasing : true
            fillMode:Image.PreserveAspectFit
        }

        Text {
            id:ateam
            text:jsonData.awayTeamAbrev
            color:winningTeam(jsonData.awayTeamWinner)
            font.pointSize:12
            anchors.topMargin:10
            anchors.leftMargin:5
            anchors.rightMargin:20
            anchors.top:rect1.top
            anchors.right:ats.left

            Text {
                id:atr
                text:"("+jsonData.awayTeamRecord+")"
                color:"gray"
                font.pointSize:8
                antialiasing : true
                anchors.horizontalCenter:parent.horizontalCenter
                anchors.top:parent.bottom
            }
        }

        Text {
            id:ats
            text:jsonData.awayTeamScore
            color:winningTeam(jsonData.awayTeamWinner)
            font.pointSize:16
            anchors.topMargin:10
            anchors.top:rect1.top
            anchors.right:gameStatus.left
            anchors.leftMargin:10
            anchors.rightMargin:20
        }

        Text {
            id:gameStatus
            text:jsonData.gameState()
            color:"white"
            font.pointSize:8
            anchors.topMargin:15
            anchors.top:rect1.top
            anchors.horizontalCenter:rect1.horizontalCenter

            Text {
                text:(jsonData.gameStatusState == "in" && (jsonData.gameType == "NBA")) ? jsonData.gameClock : Qt.formatDateTime(new Date(jsonData.gameDate),"M/dd/yy")
                color:"gray"
                font.pointSize:8
                anchors.top:parent.bottom
                anchors.horizontalCenter:parent.horizontalCenter
            }
        }

        Text {
            id:hts
            text:jsonData.homeTeamScore
            color:winningTeam(jsonData.homeTeamWinner)
            font.pointSize:16
            anchors.left:gameStatus.right
            anchors.top:rect1.top
            anchors.rightMargin:5
            anchors.leftMargin:20
            anchors.topMargin:10
        }

        Text {
            id:hta
            text:jsonData.homeTeamAbrev
            color:winningTeam(jsonData.homeTeamWinner)
            font.pointSize:12
            anchors.topMargin:10
            anchors.leftMargin:20
            anchors.rightMargin:5
            anchors.top:rect1.top
            anchors.left:hts.right

            Text {
                text:"("+jsonData.homeTeamRecord+")"
                color:"gray"
                font.pointSize:8
                anchors.top:parent.bottom
                anchors.horizontalCenter:parent.horizontalCenter
            }
        }

        Image{
            id:htl
            source:jsonData.homeTeamLogo
            //height:36
            width:32
            anchors.topMargin:10
            anchors.leftMargin:20
            anchors.rightMargin:20
            anchors.top:rect1.top
            anchors.left:hta.right
            antialiasing : true
            fillMode:Image.PreserveAspectFit
        }

        Text {
            anchors.bottom:rect1.bottom
            anchors.left:rect1.left
            anchors.bottomMargin:2
            text:jsonData.gameHeadline
            color:Theme.textColor
            font.pointSize:8
            antialiasing : true
            leftPadding:5
            width:rect1.width*.97
            elide: Text.ElideRight
            wrapMode: Text.NoWrap
        }
    }
}
