import QtQuick 2.9
import org.kde.plasma.core 2.1
import QtQuick.Layouts 1.5
import QtQuick.Controls 2.5
Item {
    id:stockData   // format stock data
    height:200
    width:340

    property var finTitles:["DOW","NASDAQ","S&P 500","OIL","GOLD","10Y BOND"]

    function isPositive(num)
    {
        if(num < 0)
            return false;
        else
            return true;
    }

    Image {
        source:"nyse.png"
        width:56
        height:42
        anchors.left:stockData.left
        anchors.top:stockData.top
        anchors.leftMargin:-5
        smooth:true
        opacity:.40
    }

ColumnLayout {
    id:titles
    height:20
    width:stockData.width
    spacing:2
    Layout.alignment: Qt.AlignHCenter

    Text {
            id:summaryMarkets
            text:"Market Summary"
            Layout.alignment: Qt.AlignHCenter
            Layout.topMargin:2
            font.pointSize:10
            color:Theme.textColor
            antialiasing : true;

            MouseArea {
                anchors.fill: parent
                onClicked: Qt.openUrlExternally("https://finance.yahoo.com/topic/stock-market-news/")
                cursorShape :Qt.PointingHandCursor
                hoverEnabled: true
                onEntered: summaryMarkets.color=Theme.viewHoverColor
                onExited: summaryMarkets.color=Theme.textColor
            }
    }

        Text {
            id:marketDate
            text:jsonData.mdate
            //anchors.top:parent.bottom
            //anchors.horizontalCenter:parent.horizontalCenter
            Layout.alignment: Qt.AlignHCenter
            font.pointSize:10
            color:Theme.textColor
            antialiasing : true;
        }

            Rectangle {
            id:ts1
            //anchors.horizontalCenter:todayMain.horizontalCenter
            //anchors.left:mkt.left
            anchors.top:marketDate.bottom
            Layout.alignment: Qt.AlignHCenter
            anchors.topMargin:5
            width: stockData.width*.95
            height: .5
            color: "#5b565d"
            antialiasing : true
        }
}

    Component {
        id: mrkts

        ColumnLayout { spacing:12; id:titles; Layout.alignment:Qt.AlignRight

            RowLayout {
                id:idx
                spacing:5
                Layout.leftMargin:15

                Text {
                    text:finTitles[index]
                    color:Theme.textColor
                    font.pointSize:10
                    Layout.leftMargin:5
                    Layout.preferredWidth:70
                    Layout.fillWidth:true
                    Layout.alignment:Qt.AlignRight
                    antialiasing : true
                }

                Text {
                    text:(typeof(jsonData.finClose[index])!="undefined") ? isPositive(jsonData.finClose[index]-jsonData.finPrevClose[index])  ? "▲":"▼" : "▲"
                    color:(typeof(jsonData.finClose[index])!="undefined") ? isPositive(jsonData.finClose[index]-jsonData.finPrevClose[index]) ? "green":"red" : "white"
                    font.pointSize:12
                    antialiasing : true
                    Layout.leftMargin:5
                    Layout.preferredWidth:20
                    Layout.fillWidth:true
                    font.bold:true
                    horizontalAlignment: Text.AlignRight
                }


                Text {
                    text:(typeof(jsonData.finClose[index])!="undefined") ? jsonData.formatNumber(jsonData.finClose[index]):"NA"
                    color:Theme.textColor
                    font.pointSize:10
                    antialiasing : true
                    Layout.leftMargin:1
                    Layout.preferredWidth:90
                    Layout.fillWidth:true
                    horizontalAlignment: Text.AlignRight
                }

                Text {
                    text:(typeof(jsonData.finClose[index])!="undefined") ? jsonData.formatNumber((jsonData.finClose[index]-jsonData.finPrevClose[index]).toFixed(2)):"NA"
                    color:(typeof(jsonData.finClose[index])!="undefined") ? isPositive(jsonData.finClose[index]-jsonData.finPrevClose[index]) ? "green":"red" : "white"
                    font.pointSize:10
                    antialiasing : true
                    Layout.leftMargin:25
                    Layout.preferredWidth:65
                    Layout.fillWidth:true
                    horizontalAlignment: Text.AlignRight
                }
            }
        }
    }

        ListView {
            id:marketData
            width:stockData.width
            height:stockData.height
            anchors.top:titles.bottom
            anchors.topMargin:30
            model: 6
            delegate: mrkts
            spacing: 7
        }
}
