import QtQuick 2.9
import org.kde.plasma.core 2.1
import QtQuick.Layouts 1.5
import QtQuick.Controls 2.5
import QtGraphicalEffects 1.5

Item {
    id:todayMain
    width:340
    height:830
    anchors.left:root.left
    anchors.top:root.top
    anchors.topMargin:10

//GetData {id:jsonData}
IconItem {
        id:refreshButton
        anchors.top:parent.top
        anchors.right:parent.right
        anchors.rightMargin:5
        anchors.topMargin:5
        source:"system-restart-symbolic"
        width:18
        height:16
        smooth:true

        MouseArea {
            anchors.fill: parent
            onClicked:jsonData.refreshData ();
            cursorShape :Qt.PointingHandCursor
            hoverEnabled: true
            onEntered: refreshIconOverlay.color=Theme.viewHoverColor
            onExited: refreshIconOverlay.color="gray" //Theme.textColor
        }

        ColorOverlay {
            id:refreshIconOverlay
            anchors.fill: refreshButton
            source: refreshButton
            color: "gray" //Theme.textColor
        }
    }

        Gmail {id:gmailModule
            anchors.top:parent.top
            anchors.horizontalCenter:parent.horizontalCenter
        }

         Rectangle {
            id:ts1
            anchors.top:gmailModule.bottom
            anchors.topMargin:5
            anchors.horizontalCenter:parent.horizontalCenter
            width: parent.width*.95
            height: .5
            color: "#5b565d"
            antialiasing : true
        }

        News {
            id:newsModule
            anchors.top:ts1.bottom
            anchors.topMargin:5
            anchors.left:parent.left
            height:35
        }

        Stocks {
            id:stocksModule
            anchors.top:newsModule.bottom
            anchors.topMargin:5
            //anchors.left:todayMain.left
            height:200
        }

        Rectangle {
            id:ts2
            anchors.horizontalCenter:parent.horizontalCenter
            anchors.top:stocksModule.bottom
            anchors.topMargin:10
            width: parent.width*.95
            height: .5
            color: "#5b565d"
            antialiasing : true
        }

        Scores {
            id:scoresModule
            anchors.top:ts2.bottom
            anchors.topMargin:5
            anchors.left:parent.left
            height:75
        }

       Rectangle {
            id:ts3
            anchors.horizontalCenter:parent.horizontalCenter
            anchors.top:scoresModule.bottom
            width: parent.width*.95
            height: .5
            color: "#5b565d"
            antialiasing : true
        }

        Weather {
            id:weatherModule
            anchors.top:ts3.bottom
            anchors.left:parent.left
            anchors.topMargin:10
        }
}
