import QtQuick 2.9
import org.kde.plasma.core 2.1
import QtQuick.Layouts 1.5
import QtQuick.Controls 2.5
import QtGraphicalEffects 1.5

Rectangle {
    id:todayMain
    color:"black"
    width:340
    height:840

GetData {id:jsonData}
IconItem {
        id:refreshButton
        anchors.top:todayMain.top
        anchors.right:todayMain.right
        anchors.rightMargin:5
        anchors.topMargin:5
        source:"system-restart-symbolic"
        width:18
        height:16
        smooth:true

        MouseArea {
            anchors.fill: parent
            onClicked:jsonData.refreshData ();
            cursorShape :Qt.PointingHandCursor
            hoverEnabled: true
            onEntered: refreshIconOverlay.color=Theme.viewHoverColor
            onExited: refreshIconOverlay.color="gray" //Theme.textColor
        }

        ColorOverlay {
            id:refreshIconOverlay
            anchors.fill: refreshButton
            source: refreshButton
            color: "gray" //Theme.textColor
        }
    }

    Item {
        id:c1
        anchors.left:todayMain.left
        anchors.top:todayMain.top
        //spacing:1

        Gmail {id:gmail;}

         Rectangle {
            id:ts1
            anchors.top:gmail.bottom
            anchors.topMargin:5
            anchors.horizontalCenter:todayMain.horizontalCenter
            width: todayMain.width*.95
            height: .5
            color: "#5b565d"
            antialiasing : true
        }

        News {
            id:news
            anchors.top:ts1.bottom
            anchors.topMargin:5
            anchors.left:todayMain.left
            height:45
        }

        Stocks {
            id:stocks
            anchors.top:news.bottom
            anchors.topMargin:5
            anchors.left:todayMain.left
            height:220
        }

        Rectangle {
            id:ts2
            anchors.horizontalCenter:todayMain.horizontalCenter
            anchors.top:stocks.bottom
            anchors.topMargin:10
            width: todayMain.width*.95
            height: .5
            color: "#5b565d"
            antialiasing : true
        }

        Scores {
            id:scores
            anchors.top:ts2.bottom
            anchors.topMargin:5
            anchors.left:todayMain.left
            height:75
        }

       Rectangle {
            id:ts3
            anchors.horizontalCenter:todayMain.horizontalCenter
            anchors.top:scores.bottom
            width: todayMain.width*.95
            height: .5
            color: "#5b565d"
            antialiasing : true
        }

        Weather {
            id:weather
            anchors.top:ts3.bottom
            anchors.left:todayMain.left
            anchors.topMargin:10
        }
    }
}
